﻿using System;
using System.Runtime.InteropServices;
using System.ComponentModel;
using System.Windows.Forms;
using AddinExpress.MSO;
using System.Diagnostics;

namespace ReplyContextMenu2007_2010
{
    /// <summary>
    ///   Add-in Express Add-in Module
    /// </summary>
    [GuidAttribute("72C77FAF-82C1-498C-B7BB-74DA2034EE95"), ProgId("ReplyContextMenu2007-2010.AddinModule")]
    public class AddinModule : AddinExpress.MSO.ADXAddinModule
    {
        public AddinModule()
        {
            Application.EnableVisualStyles();
            InitializeComponent();
            // Please add any initialization code to the AddinInitialize event handler
        }

        private ADXOutlookAppEvents adxOutlookEvents;
 
        #region Component Designer generated code
        /// <summary>
        /// Required by designer
        /// </summary>
        private System.ComponentModel.IContainer components;
 
        /// <summary>
        /// Required by designer support - do not modify
        /// the following method
        /// </summary>
        private void InitializeComponent()
        {
            this.components = new System.ComponentModel.Container();
            this.adxOutlookEvents = new AddinExpress.MSO.ADXOutlookAppEvents(this.components);
            // 
            // adxOutlookEvents
            // 
            this.adxOutlookEvents.ItemContextMenuDisplay += new AddinExpress.MSO.ADXOlContextMenu_EventHandler(this.adxOutlookEvents_ItemContextMenuDisplay);
            // 
            // AddinModule
            // 
            this.AddinName = "ReplyContextMenu2007-2010";
            this.SupportedApps = AddinExpress.MSO.ADXOfficeHostApp.ohaOutlook;
            this.AddinBeginShutdown += new AddinExpress.MSO.ADXEvents_EventHandler(this.AddinModule_AddinBeginShutdown);
            this.AddinStartupComplete += new AddinExpress.MSO.ADXEvents_EventHandler(this.AddinModule_AddinStartupComplete);

        }
        #endregion
 
        #region Add-in Express automatic code
 
        // Required by Add-in Express - do not modify
        // the methods within this region
 
        public override System.ComponentModel.IContainer GetContainer()
        {
            if (components == null)
                components = new System.ComponentModel.Container();
            return components;
        }
 
        [ComRegisterFunctionAttribute]
        public static void AddinRegister(Type t)
        {
            AddinExpress.MSO.ADXAddinModule.ADXRegister(t);
        }
 
        [ComUnregisterFunctionAttribute]
        public static void AddinUnregister(Type t)
        {
            AddinExpress.MSO.ADXAddinModule.ADXUnregister(t);
        }
 
        public override void UninstallControls()
        {
            base.UninstallControls();
        }

        #endregion

        public static new AddinModule CurrentInstance 
        {
            get
            {
                return AddinExpress.MSO.ADXAddinModule.CurrentInstance as AddinModule;
            }
        }

        public Outlook._Application OutlookApp
        {
            get
            {
                return (HostApplication as Outlook._Application);
            }
        }

        ReplyAllChecker replyAllChecker = null;

        private void AddinModule_AddinStartupComplete(object sender, EventArgs e)
        {
            Debug.Print("The AddinStartupComplete event has occured.");
            Debug.Print("The add-in has been loaded by Outlook " + this.HostMajorVersion.ToString());

            // This creates an item of the class that handles the events of an Outlook item
            replyAllChecker = new ReplyAllChecker(this);
        }

        private void AddinModule_AddinBeginShutdown(object sender, EventArgs e)
        {
            // in Outlook 2010, this event may not occur, see the blog 'Outlook 2010 Fast Shutdown feature'
            // at http://www.add-in-express.com/creating-addins-blog/2010/05/04/outlook2010-fast-shutdown/

            Debug.Print("The AddinBeginShutdown event has occured.");

            if (replyAllChecker.IsConnected)
            {
                Debug.Print("Disconnecting replyAllChecker from the previously connected item.");
                replyAllChecker.RemoveConnection();
            }
            replyAllChecker = null;
        }

        private void ConnectToSelectedItem(Outlook.Selection selection)
        {
            if (selection != null)
            {
                if (selection.Count == 1)
                {
                    object item = selection.Item(1);
                    if (item is Outlook.MailItem)
                    {
                        if (replyAllChecker.IsConnected)
                        {
                            Debug.Print("Disconnecting replyAllChecker from the previously connected item.");
                            replyAllChecker.RemoveConnection();
                        }
                        Debug.Print("Connecting replyAllChecker to this Outlook item.");
                        replyAllChecker.ConnectTo(item, true);
                    }
                    else
                    {
                        Marshal.ReleaseComObject(item);
                        Debug.Print("Do not connect to this Outlook item.");
                    }
                }
            }
        }

        private void adxOutlookEvents_ItemContextMenuDisplay(object sender, object commandBar, object target)
        {
            Debug.Print("The ItemContextMenuDisplay event has occured.");
            try
            {
                Outlook.Selection selection = target as Outlook.Selection;
                if (selection != null)
                {
                    ConnectToSelectedItem(selection);
                    Marshal.ReleaseComObject(selection);
                }
                else
                    Debug.Print("No items are selected.");
            }
            catch { }
        }

    }
}

